\section{Architectural Representation}

%[This section describes what software architecture is for the current system, and how it is represented. Of the Use-Case, Logical, Process, Deployment, and Implementation Views, it enumerates the views that are necessary, and for each view, explains what types of model elements it contains.]

The software will have a number of closely related purposes (\cite{knmi:sw:highleveldescription}):

\begin{itemize}
\item Visualisation for real-time monitoring: To help back-office personnel to monitor the current space weather situation by presenting a visualisation of real-time observation and model data, as the data comes in. 
\item Visualisation for space weather training and research: To allow space weather back-office personnel to browse through archived operational as well as scientific space weather data, using visualisations of such data that are the same as that of the real-time monitoring, in order to provide insight in data of past space weather events, as well as possible data quality issues.
\item Library for space weather data research in Python: The software library that manages the storage and retrieval of data for the visualisation described above must also be usable without the visualisation part of the software, from any Python script or Jupyter notebook, for further manipulation of the space weather data for research purposes.
\item External presentation: To allow for back-office personnel to make a selection of space weather visualisations, representative of current space weather or recent space weather events, to be displayed on one or more computer-connected screens in the corridors of the KNMI building. This will be done in order to increase the visibility and awareness of space weather and KNMI's role in the space weather domain. This functionality can also be used to prototype display of space weather status information for the client (government crisis coordination) on a future section of the KNMI web portal.
\item Research to operations: Back-office personnel must be able to add new data parsing and visualisation elements to the software relatively quickly and easily, to test working with new data types and alternative data sources. Such new elements can be made based on the templates of already implemented elements.
\end{itemize}

\section{Architectural Goals and Constraints}

[This section describes the software requirements and objectives that have some significant impact on the architecture; for example, safety, security, privacy, use of an off-the-shelf product, portability, distribution, and reuse. It also captures the special constraints that may apply: design and implementation strategy, development tools, team structure, schedule, legacy code, and so on.]

\section{Use-Case View}

[This section lists use cases or scenarios from the use-case model if they represent some significant, central functionality of the final system, or if they have a large architectural coverage—they exercise many architectural elements or if they stress or illustrate a specific, delicate point of the architecture.]

\subsection{Use-Case Realizations}

[This section illustrates how the software actually works by giving a few selected use-case (or scenario) realizations, and explains how the various design model elements contribute to their functionality.]

\section{Logical View}

[This section describes the architecturally significant parts of the design model, such as its decomposition into subsystems and packages. And for each significant package, its decomposition into classes and class utilities. You should introduce architecturally significant classes and describe their responsibilities, as well as a few very important relationships, operations, and attributes.]

\subsection{Overview}

[This subsection describes the overall decomposition of the design model in terms of its package hierarchy and layers.]

\subsection{Architecturally Significant Design Packages}

[For each significant package, include a subsection with its name, its brief description, and a diagram with all significant classes and packages contained within the package. 
For each significant class in the package, include its name, brief description, and, optionally, a description of some of its major responsibilities, operations, and attributes.]

\section{Process View}

[This section describes the system's decomposition into lightweight processes (single threads of control) and heavyweight processes (groupings of lightweight processes). Organize the section by groups of processes that communicate or interact. Describe the main modes of communication between processes, such as message passing, interrupts, and rendezvous.]

\section{Deployment View}

[This section describes one or more physical network (hardware) configurations on which the software is deployed and run. It is a view of the Deployment Model. At a minimum for each configuration it should indicate the physical nodes (computers, CPUs) that execute the software and their interconnections (bus, LAN, point-to-point, and so on.) Also include a mapping of the processes of the Process View onto the physical nodes.]

\section{Implementation View}

[This section describes the overall structure of the implementation model, the decomposition of the software into layers and subsystems in the implementation model, and any architecturally significant components.]

\subsection{Overview}

[This subsection names and defines the various layers and their contents, the rules that govern the inclusion to a given layer, and the boundaries between layers. Include a component diagram that shows the relations between layers. ]

\subsection{Layers}

[For each layer, include a subsection with its name, an enumeration of the subsystems located in the layer, and a component diagram.]

\section{Data View (optional)}

[A description of the persistent data storage perspective of the system. This section is optional if there is little or no persistent data, or the translation between the Design Model and the Data Model is trivial.]

\cite{knmi:sw:datasources}

\section{Size and Performance} 

[A description of the major dimensioning characteristics of the software that impact the architecture, as well as the target performance constraints.]

\section{Quality}

[A description of how the software architecture contributes to all capabilities (other than functionality) of the system: extensibility, reliability, portability, and so on. If these characteristics have special significance, such as safety, security or privacy implications, they must be clearly delineated.]

